// singleton_test.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "singleton.h"
class SingletonClassB;
class SingletonClassA
{
DECLARE_SINGLETON_DEPENDENTS(SingletonClassA, BUILD_TYPE_LIST_1(SingletonClassB))
SingletonClassA() {}
~SingletonClassA() {}
};

class SingletonClassB
{
DECLARE_SINGLETON_DEPENDENTS(SingletonClassB, end_of_type_list)
SingletonClassB() {}
~SingletonClassB() {}
};

IMPLEMENT_SINGLETON(SingletonClassA)
IMPLEMENT_SINGLETON(SingletonClassB)

int main(int argc, char* argv[])
{
	SingletonClassA *a = &GET_SINGLETON(SingletonClassA);
	SingletonClassB *b = &GET_SINGLETON(SingletonClassB);
	return 0;
}
